/****************************************************************
*	CHREDIR.C - set up files as the default devices (handles	*
*	0 through 4), and call a child program that outputs to each	*
*	of the output handles, so we can capture it.				*
*																*
*	To compile "tcc chredir"									*
****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>

#define EXMSG(x) { puts("ERROR: " #x ".\n"); exit(1); }

void main(void)
	{
	int oldstdout, newfile;

	/*---------Redirect standard output to file "stdout"--------*/
	oldstdout = dup(fileno(stdout));
	if (oldstdout == -1)
		EXMSG("Can\'t duplicate STDOUT file handle")
	newfile = open("stdout",O_WRONLY|O_TRUNC|O_CREAT|O_TEXT,
					S_IREAD|S_IWRITE);
	if (newfile == -1)
		EXMSG("Can\'t open \"stdout\"")
	if (dup2(newfile,fileno(stdout)))
		EXMSG("Can\'t overlay the stdout file handle")
	if (close(newfile))
		EXMSG("Can\'t close \"stdout\"")

	/*------Execute a COPY command, and capture the output------*/
	system("copy chredir.c chredir.d");

	/*--------Restore standard output to original state---------*/
	if (dup2(oldstdout,fileno(stdout)))
		EXMSG("Can\'t restore stdout file handle")
	if (close(oldstdout))
		EXMSG("Can\'t close file")
	}
