/****************************************************************
* FT.C - function tables demonstration							*
*																*
* To compile, use: "tcc ft.c /link graph"						*
****************************************************************/

#include <stdio.h>
#include <graphics.h>
#include <string.h>
#include <conio.h>

/****************************************************************
* The functions referenced in the function table				*
****************************************************************/

void f40init(void)		/* Set video to 40x25 color text mode	*/
	{
	textmode(C40);
	}

void f80init(void)		/* Set video to 80x25 color text mode	*/
	{
	textmode(C80);
	}

void f40ctr(char *s)	/* Print string at center of screen		*/
	{
	int i;
	i=strlen(s);					/* What is length of string?*/
	if (i>38) s[38]='\0';			/* Truncate if too long		*/
	gotoxy(20-i/2,12);				/* Set cursor position		*/
	cputs(s);						/* Print the string			*/
	}

void f80ctr(char *s)	/* Print string @ center of 80x25 screen*/
	{
	int i;
	i=strlen(s);					/* Get length of string		*/
	if (i>78) s[78]='\0';			/* Truncate if too long		*/
	gotoxy(40-i/2,12);				/* Set cursor position		*/
	cputs(s);						/* Print the string			*/
	}

/****************************************************************
* The function table declaration								*
****************************************************************/
void (*ft[2][2])() =
	{
		/*  Initialize		Print at center						*/
		/*	   CRT			    of CRT							*/
		{	 f40init,		    f40ctr	},	/* 40x25 mode		*/
		{	 f80init,			f80ctr	}	/* 80x25 mode		*/
	};
int ScreenType;
#define COLUMNS_40		0
#define COLUMNS_80		1
#define InitScreen		(*ft[ScreenType][0])
#define PrintAtCenter	(*ft[ScreenType][1])

/****************************************************************
* main demonstration program									*
****************************************************************/
void main(void)
	{
	ScreenType = COLUMNS_40;
	InitScreen();
	PrintAtCenter("Inside Turbo C");
	getch();

	ScreenType = COLUMNS_80;
	InitScreen();
	PrintAtCenter("Inside Turbo C");
	getch();
	}
